## fennel 1.5.1+dfsg

=== debian/changelog ===
fennel (1.5.1+dfsg-2) unstable; urgency=medium

  * Source-only upload for buildd
  * Add myself to Uploaders

 -- Blair Noctis <ncts@debian.org>  Thu, 10 Oct 2024 16:42:14 +0000

fennel (1.5.1+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #919930)

 -- Phil Hagelberg <phil@hagelb.org>  Sun, 25 Aug 2024 11:34:25 -0700
