=== debian/rules ===
#!/usr/bin/make -f

export PREFIX = /usr

%:
	dh $@

# it's unclear why dh_auto_clean does not invoke this for us
execute_after_dh_clean: ; $(MAKE) clean
