## fennel 1.5.3+dfsg

=== debian/changelog ===
fennel (1.5.3+dfsg-2) unstable; urgency=medium

  * Disable tests on platforms that don't have working LuaJIT

 -- Phil Hagelberg <phil@hagelb.org>  Wed, 26 Feb 2025 17:05:05 -0800

fennel (1.5.3+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Remove patch for irc.lua which is no longer necessary
  * Add to clean rule to work around missing entry in upstream makefile

 -- Phil Hagelberg <phil@hagelb.org>  Sun, 16 Feb 2025 15:34:15 -0800
