=== debian/rules ===
#!/usr/bin/make -f

export PREFIX = /usr
export LUA = lua5.4

%:
	dh $@

# it's unclear why dh_auto_clean does not invoke this for us
execute_after_dh_clean:
	$(MAKE) clean
	rm -f bootstrap/macros.lua bootstrap/match.lua
# ^ TODO: this can be removed after the next release; it was missing from the
# upstream clean target in 1.5.3 but added immediately after.
