## fennel 1.6.0%2Bdfsg

=== Makefile ===
--- 
+++ 
@@ -47,7 +47,7 @@
 format: ; for f in $(SRC); do fnlfmt --fix $$f ; done
 
 # All-in-one pure-lua script:
-fennel: src/launcher.fnl $(SRC) $(PRECOMPILED)
+fennel: src/launcher.fnl $(SRC) bootstrap/aot.lua $(PRECOMPILED)
 	@echo "#!/usr/bin/env $(LUA)" > $@
 	@echo "-- SPDX-License-Identifier: MIT" >> $@
 	@echo "-- SPDX-FileCopyrightText: Calvin Rose and contributors" >> $@
@@ -71,11 +71,12 @@
 lint:
 	fennel-ls --lint $(SRC)
 
-ci: testall fuzz fennel
+ci: testall fuzz fennel fennel-bin
+	./fennel-bin --eval '(print "binary works!")'
 
 clean:
 	rm -f fennel.lua fennel fennel-bin fennel.exe \
-		*_binary.c luacov.* bootstrap/view.lua \
+		*_binary.c luacov.* $(PRECOMPILED) \
 		test/faith.lua build/manfilter.lua fennel-bin-luajit
 	$(MAKE) -C $(BIN_LUA_DIR) clean || true # this dir might not exist
 	$(MAKE) -C $(BIN_LUAJIT_DIR) clean || true # this dir might not exist
@@ -145,9 +146,9 @@
 		$(call maninst,$(doc),$(DESTDIR)$(MAN_DIR)/$(doc)))
 
 uninstall:
-	rm $(DESTDIR)$(BIN_DIR)/fennel
-	rm $(DESTDIR)$(LUA_LIB_DIR)/fennel.lua
-	rm $(addprefix $(DESTDIR)$(MAN_DIR)/,$(MAN_DOCS))
+	rm -f $(DESTDIR)$(BIN_DIR)/fennel
+	rm -f $(DESTDIR)$(LUA_LIB_DIR)/fennel.lua
+	rm -f $(addprefix $(DESTDIR)$(MAN_DIR)/,$(MAN_DOCS))
 
 build/manfilter.lua: build/manfilter.fnl fennel.lua fennel
 	./fennel --correlate --compile $< > $@
@@ -156,13 +157,13 @@
 man/man%/: ; mkdir -p $@
 man/man3/fennel-%.3: %.md build/manfilter.lua
 	$(MAN_PANDOC) $< -o $@
-	sed -i 's/\\f\[C\]/\\f[CR]/g' $@ # work around pandoc 2.x bug
+	sed -i.tmp 's/\\f\[C\]/\\f[CR]/g' $@ # work around pandoc 2.x bug
 man/man5/fennel-%.5: %.md build/manfilter.lua
 	$(MAN_PANDOC) $< -o $@
-	sed -i 's/\\f\[C\]/\\f[CR]/g' $@
+	sed -i.tmp 's/\\f\[C\]/\\f[CR]/g' $@ # work around pandoc 2.x bug
 man/man7/fennel-%.7: %.md build/manfilter.lua
 	$(MAN_PANDOC) $< -o $@
-	sed -i 's/\\f\[C\]/\\f[CR]/g' $@
+	sed -i.tmp 's/\\f\[C\]/\\f[CR]/g' $@ # work around pandoc 2.x bug
 
 ## Release-related tasks:
 
@@ -201,7 +202,7 @@
 
 prerelease: guard-VERSION ci test-builds
 	@echo "Did you look for changes that need to be mentioned in help/man text?"
-	sed -i s/$(VERSION)-dev/$(VERSION)/ src/fennel/utils.fnl
+	sed -i.tmp s/$(VERSION)-dev/$(VERSION)/ src/fennel/utils.fnl
 	$(MAKE) man
 	grep "$(VERSION)" setup.md > /dev/null
 	! grep "???" changelog.md
