## fennel 1.6.0+dfsg

=== debian/changelog ===
fennel (1.6.0+dfsg-1) unstable; urgency=medium

  * New upstream release: 1.6.0

  [ Blair Noctis ]
  * Disable make targets requiring git

 -- Phil Hagelberg <phil@hagelb.org>  Mon, 20 Oct 2025 14:44:00 +0000
