=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
- lua5.4 | lua,
+ lua5.4
 Recommends:
  lua-readline
 Description: Lisp-based programming language for the Lua runtime
