=== debian/tests/control ===
Test-Command: make ci
Depends: lua5.1, lua5.2, lua5.3, lua5.4, luajit, make
Restrictions: allow-stderr
Architecture: !ppc64el !riscv64

# ppc64el lacks luajit entirely; would be better to run the tests without
# luajit on that arch, but for now we just disable it entirely.

# riscv64 seems to fail CI due to an arch-specific bug in luajit:
# https://ci.debian.net/packages/f/fennel/testing/riscv64/57941630/

# allow-stderr because for unknown reasons the test run gives us:
# autopkgtest [09:50:54]: test command1:  - - - - - - - - - - results - - - - - - - - - -
# command1             FAIL stderr: Lua 5.1.5  Copyright (C) 1994-2012 Lua.org, PUC-Rio
# despite this not happening when `make ci' is run normally.
