=== debian/watch ===
version=4
opts="mode=git,pgpmode=gittag,repacksuffix=+dfsg,dversionmangle=auto" \
https://git.sr.ht/~technomancy/@PACKAGE@ refs/tags/@ANY_VERSION@
